;
(function() {
    App.defineViewModel("#demo", {
        data: {
            show: false,
            show1: false,
            transitionName: 'expand',
            query: '',
            list:[
                {name: 'apple'},
                {name: 'peach'},
                {name: 'orange'},
                {name: 'banana'},
                {name: 'lemon'}
            ]
        },
        watch: {},
        methods: {}
    }, {
        ready: function() {},
        beforeRender: function(params) {},
        afterRender: function(params) {},
        beforeUnRender: function() {},
        afterUnRender: function() {}
    });
    

    //与css结合时的JavaScript钩子
    Light.Model.transition('expand', {
        beforeEnter: function(el) {
            el.textContent = 'beforeEnter'
        },
        enter: function(el) {
            el.textContent = 'enter'
        },
        afterEnter: function(el) {
            el.textContent = 'afterEnter'
        },
        enterCancelled: function(el) {},
        beforeLeave: function(el) {
            el.textContent = 'beforeLeave'
        },
        leave: function(el) {
            el.textContent = 'leave'
        },
        afterLeave: function(el) {
            el.textContent = 'afterLeave'
        },
        leaveCancelled: function(el) {}
    })

    //单独使用JavaScript钩子
    Light.Model.transition('fade', {
        css: false, //跳过css检测，防止css规则干扰过渡
        beforeEnter: function(el) {
            $(el).css({'width': '100px', 'height': '50px','background': '#50a0b4'});
        },
        enter: function(el, done) {
            // 元素已被插入 DOM
            // 在动画结束后调用 done
            $(el)
                .css('opacity', 0)
                .animate({
                    opacity: 1
                }, 400, done)
        },
        enterCancelled: function(el) {
            $(el).stop()
        },
        leave: function(el, done) {
            // 与 enter 相同
            $(el).animate({
                opacity: 0
            }, 1000, done)
        },
        leaveCancelled: function(el) {
            $(el).stop()
        }
    })


    //渐进过渡的JavaScript钩子
    Light.Model.transition('staggered', {
        stagger: function(index) {
            // 每个过渡项目增加 50ms 延时
            // 但是最大延时限制为 300ms
            return Math.min(300, index * 50)
        }
    })
})();